diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/formats/luks.py anaconda-storage/storage/formats/luks.py
--- anaconda/storage/formats/luks.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/formats/luks.py	2009-02-15 13:04:52.000000000 -0600
@@ -0,0 +1,202 @@
+# luks.py
+# Device format classes for anaconda's storage configuration module.
+#
+# Copyright (C) 2009  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
+#
+
+
+
+import os
+
+from errors import *
+from iutil import log_method_call
+from deviceformat import *
+import crypto
+
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+import logging
+log = logging.getLogger("storage")
+
+
+class LUKS(DeviceFormat):
+    """ A LUKS device. """
+    _type = "luks"
+    _udevTypes = ["crypto_LUKS"]
+    _formattable = True                 # can be formatted
+    _supported = True                   # is supported
+    _linuxNative = True                 # for clearpart
+    _packages = ["cryptsetup-luks"]     # required packages
+
+    def __init__(self, *args, **kwargs):
+        """ Create a LUKS instance.
+
+            Keyword Arguments:
+
+                device -- the path to the underlying device
+                name -- the name of the mapped device
+                uuid -- this device's UUID
+                passphrase -- device passphrase (string)
+                key_file -- path to a file containing a key (string)
+                cipher -- cipher mode string
+                key_size -- key size in bits
+                exists -- indicates whether this is an existing format
+        """
+        log_method_call(self, *args, **kwargs)
+        DeviceFormat.__init__(self, *args, **kwargs)
+        self.cipher = kwargs.get("cipher")
+        self.key_size = kwargs.get("key_size")
+        self.mapName = kwargs.get("name")
+
+        # FIXME: these should both be lists, but managing them will be a pain
+        self.__passphrase = kwargs.get("passphrase")
+        self._key_file = kwargs.get("key_file")
+
+        if not self.mapName:
+            self.mapName = "luks-%s" % os.path.basename(self.device)
+
+    @property
+    def status(self):
+        if not self.exists:
+            return False
+        return os.path.exists("/dev/mapper/%s" % self.mapName)
+
+    def probe(self):
+        """ Probe for any missing information about this format.
+
+            cipher mode, key size
+        """
+        raise NotImplementedError("probe method not defined for LUKS")
+
+    def setup(self):
+        """ Open, or set up, the format. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise LUKSError("format has not been created")
+
+        if self.status:
+            return
+
+        crypto.luks_open(self.device, self.mapName,
+                       passphrase=self.__passphrase,
+                       key_file=self._key_file)
+
+        # XXX hack
+        #import udev as _udev
+        #_udev.udev_settle()
+        #del _udev
+
+    def teardown(self):
+        """ Close, or tear down, the format. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise LUKSError("format has not been created")
+
+        if self.status:
+            log.debug("unmapping %s" % self.mapName)
+            crypto.luks_close(self.mapName)
+
+    def create(self):
+        """ Create the format. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if self.exists:
+            raise LUKSError("format already exists")
+
+        crypto.luks_format(self.device,
+                         passphrase=self.__passphrase,
+                         key_file=self._key_file,
+                         cipher=self.cipher,
+                         key_size=self.key_size)
+
+        self.uuid = crypto.luks_uuid(self.device)
+        self.notifyKernel()
+
+    @property
+    def keyFile(self):
+        """ Path to key file to be used in /etc/crypttab """
+        return self._key_file
+
+    def addKeyFromFile(self, keyfile):
+        """ Add a new key from a file.
+
+            Add the contents of the specified key file to an available key
+            slot in the LUKS header.
+        """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status, file=keyfile)
+        if not self.exists:
+            raise LUKSError("format has not been created")
+
+        crypto.luks_add_key(self.device,
+                          passphrase=self.__passphrase,
+                          key_file=self._key_file,
+                          new_key_file=keyfile)
+
+    def addPassphrase(self, passphrase):
+        """ Add a new passphrase.
+
+            Add the specified passphrase to an available key slot in the
+            LUKS header.
+        """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise LUKSError("format has not been created")
+
+        crypto.luks_add_key(self.device,
+                          passphrase=self.__passphrase,
+                          key_file=self._key_file,
+                          new_passphrase=passphrase)
+
+    def removeKeyFromFile(self, keyfile):
+        """ Remove a key contained in a file.
+
+            Remove key contained in the specified key file from the LUKS
+            header.
+        """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status, file=keyfile)
+        if not self.exists:
+            raise LUKSError("format has not been created")
+
+        crypto.luks_remove_key(self.device,
+                             passphrase=self.__passphrase,
+                             key_file=self._key_file,
+                             del_key_file=keyfile)
+
+
+    def removePassphrase(self, passphrase):
+        """ Remove the specified passphrase from the LUKS header. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise LUKSError("format has not been created")
+
+        crypto.luks_remove_key(self.device,
+                             passphrase=self.__passphrase,
+                             key_file=self._key_file,
+                             del_passphrase=passphrase)
+
+
+register_device_format(LUKS)
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/formats/mdraidmember.py anaconda-storage/storage/formats/mdraidmember.py
--- anaconda/storage/formats/mdraidmember.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/formats/mdraidmember.py	2009-02-15 21:00:25.000000000 -0600
@@ -0,0 +1,84 @@
+# mdraidmember.py
+# Device format classes for anaconda's storage configuration module.
+#
+# Copyright (C) 2009  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
+#
+
+from errors import *
+from iutil import log_method_call
+from deviceformat import *
+import mdraid
+#from parted import PARTITION_RAID
+
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+import logging
+log = logging.getLogger("storage")
+
+
+class MDRaidMember(DeviceFormat):
+    """ An mdraid member disk. """
+    _type = "mdmember"
+    _udevTypes = ["linux_raid_member"]
+    #partedFlags = PARTITION_RAID
+    _formattable = True                 # can be formatted
+    _supported = True                   # is supported
+    _linuxNative = True                 # for clearpart
+    _packages = ["mdadm"]               # required packages
+    
+    def __init__(self, *args, **kwargs):
+        """ Create a MDRaidMember instance.
+
+            Keyword Arguments:
+
+                device -- path to underlying device
+                uuid -- this member device's uuid
+                mdUuid -- the uuid of the array this device belongs to
+                exists -- indicates whether this is an existing format
+
+        """
+        log_method_call(self, *args, **kwargs)
+        DeviceFormat.__init__(self, *args, **kwargs)
+        self.mdUuid = kwargs.get("mdUuid")
+        self.raidMinor = None
+
+        #self.probe()
+
+    def probe(self):
+        """ Probe for any missing information about this format. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise MDRaidMemberError("format has not been created")
+
+        info = mdraid.mdexamine(self.device)
+        if self.uuid is None:
+            self.uuid = info['uuid']
+        if self.raidMinor is None:
+            self.raidMinor = info['mdMinor']
+
+    @property
+    def status(self):
+        # XXX hack -- we don't have a nice way to see if the array is active
+        return False
+
+
+register_device_format(MDRaidMember)
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/formats/physicalvolume.py anaconda-storage/storage/formats/physicalvolume.py
--- anaconda/storage/formats/physicalvolume.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/formats/physicalvolume.py	2009-02-16 15:04:33.000000000 -0600
@@ -0,0 +1,116 @@
+# physicalvolume.py
+# Device format classes for anaconda's storage configuration module.
+#
+# Copyright (C) 2009  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
+#
+
+from errors import *
+from iutil import log_method_call
+from deviceformat import *
+import lvm
+#from parted import PARTITION_LVM
+
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+import logging
+log = logging.getLogger("storage")
+
+
+class PhysicalVolume(DeviceFormat):
+    """ An LVM physical volume. """
+    _type = "lvmpv"
+    _udevTypes = ["LVM2_member"]
+    #partedFlags = PARTITION_LVM
+    _formattable = True                 # can be formatted
+    _supported = True                   # is supported
+    _linuxNative = True                 # for clearpart
+    _packages = ["lvm2"]                # required packages
+
+    def __init__(self, *args, **kwargs):
+        """ Create a PhysicalVolume instance.
+
+            Keyword Arguments:
+
+                device -- path to the underlying device
+                uuid -- this PV's uuid (not the VG uuid)
+                vgName -- the name of the VG this PV belongs to
+                vgUuid -- the UUID of the VG this PV belongs to
+                peStart -- offset of first physical extent
+                exists -- indicates whether this is an existing format
+
+        """
+        log_method_call(self, *args, **kwargs)
+        DeviceFormat.__init__(self, *args, **kwargs)
+        self.vgName = kwargs.get("vgName")
+        self.vgUuid = kwargs.get("vgUuid")
+        # liblvm may be able to tell us this at some point, even
+        # for not-yet-created devices
+        self.peStart = kwargs.get("peStart", 0.1875)    # in MB
+
+    def probe(self):
+        """ Probe for any missing information about this device. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise PhysicalVolumeError("format has not been created")
+
+        pass
+        #info = lvm.pvinfo(self.device)
+        #self.vgName = info['vg_name']
+        #self.vgUuid = info['vg_uuid']
+
+    def create(self):
+        """ Create the format. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if self.exists:
+            raise PhysicalVolumeError("format already exists")
+
+        """ Consider use of -Z|--zero
+            -f|--force or -y|--yes may be required
+        """
+        lvm.pvcreate(self.device)
+        self.notifyKernel()
+
+    def destroy(self):
+        """ Destroy the format. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise PhysicalVolumeError("format has not been created")
+
+        if self.status:
+            raise PhysicalVolumeError("device is active")
+
+        # FIXME: verify path exists?
+        lvm.pvremove(self.device)
+        self.notifyKernel()
+
+    @property
+    def status(self):
+        # XXX hack
+        for d in os.listdir("/dev/mapper"):
+            if d.startswith("%s-" % self.vgName):
+                return True
+        return False
+
+
+register_device_format(PhysicalVolume)
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/formats/swapspace.py anaconda-storage/storage/formats/swapspace.py
--- anaconda/storage/formats/swapspace.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/formats/swapspace.py	2009-02-13 13:16:20.000000000 -0600
@@ -0,0 +1,118 @@
+# swapspace.py
+# Device format classes for anaconda's storage configuration module.
+#
+# Copyright (C) 2009  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
+#
+
+import os
+
+from errors import *
+from iutil import log_method_call
+from deviceformat import *
+import swap
+#from parted import PARTITION_SWAP
+
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+import logging
+log = logging.getLogger("storage")
+
+
+class SwapSpace(DeviceFormat):
+    """ Swap space """
+    _type = "swap"
+    _udevTypes = ["swap"]
+    #partedFlags = PARTITION_SWAP
+    _formattable = True                # can be formatted
+    _supported = True                  # is supported
+    _linuxNative = True                # for clearpart
+
+    def __init__(self, *args, **kwargs):
+        """ Create a SwapSpace instance.
+
+            Keyword Arguments:
+
+                device -- path to the underlying device
+                uuid -- this swap space's uuid
+                label -- this swap space's label
+                priority -- this swap space's priority
+                exists -- indicates whether this is an existing format
+
+        """
+        log_method_call(self, *args, **kwargs)
+        DeviceFormat.__init__(self, *args, **kwargs)
+
+        priority = kwargs.get("priority")
+        if priority is not None:
+            if not isinstance(priority, int) or not 0 <= priority <= 32767:
+                raise ValueError("swap priority must be an integer between 0 and 32767")
+        self._priority = priority
+        self.label = kwargs.get("label")
+
+    @property
+    def options(self):
+        opts = ""
+        if self.priority is not None:
+            opts += "pri=%d" % self.priority
+
+        return opts
+
+    @property
+    def status(self):
+        """ Device status. """
+        return self.exists and swap.swapstatus(self.device)
+
+    def setup(self):
+        """ Open, or set up, a device. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise SwapSpaceError("format has not been created")
+
+        if self.status:
+            return
+
+        swap.swapon(self.device, priority=self.priority)
+
+    def teardown(self):
+        """ Close, or tear down, a device. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if not self.exists:
+            raise SwapSpaceError("format has not been created")
+
+        if self.status:
+            swap.swapoff(self.device)
+
+    def create(self):
+        """ Create the device. """
+        log_method_call(self, device=os.path.basename(self.device),
+                        type=self.type, status=self.status)
+        if self.exists:
+            raise SwapSpaceError("format already exists")
+
+        if self.status:
+            raise SwapSpaceError("device exists and is active")
+
+        swap.mkswap(self.device, label=self.label)
+
+
+register_device_format(SwapSpace)
+
